Overview | Package | Class | Use | Tree | Deprecated | Index | Help
|  | BEA Systems, Inc.
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## weblogic.apache.xerces.dom
Class EntityReferenceImpl

    java.lang.Object
      |
      +--weblogic.apache.xerces.dom.NodeImpl
            |
            +--weblogic.apache.xerces.dom.ChildNode
                  |
                  +--weblogic.apache.xerces.dom.ParentNode
                        |
                        +--weblogic.apache.xerces.dom.EntityReferenceImpl

Direct Known Subclasses:
  DeferredEntityReferenceImpl

public class EntityReferenceImpl
extends ParentNode
implements org.w3c.dom.EntityReference

EntityReference models the XML &entityname; syntax, when used for entities defined by the DOM. Entities hardcoded into XML, such as character entities, should instead have been translated into text by the code which generated the DOM tree.

An XML processor has the alternative of fully expanding Entities into the normal document tree. If it does so, no EntityReference nodes will appear.

Similarly, non-validating XML processors are not required to read or process entity declarations made in the external subset or declared in external parameter entities. Hence, some applications may not make the replacement value available for Parsed Entities of these types.

EntityReference behaves as a read-only node, and the children of the EntityReference (which reflect those of the Entity, and should also be read-only) give its replacement value, if any. They are supposed to automagically stay in synch if the DocumentType is updated with new values for the Entity.

The defined behavior makes efficient storage difficult for the DOM implementor. We can't just look aside to the Entity's definition in the DocumentType since those nodes have the wrong parent (unless we can come up with a clever "imaginary parent" mechanism). We must at least appear to clone those children... which raises the issue of keeping the reference synchronized with its parent. This leads me back to the "cached image of centrally defined data" solution, much as I dislike it.

For now I have decided, since REC-DOM-Level-1-19980818 doesn't cover this in much detail, that synchronization doesn't have to be considered while the user is deep in the tree. That is, if you're looking within one of the EntityReferennce's children and the Entity changes, you won't be informed; instead, you will continue to access the same object -- which may or may not still be part of the tree. This is the same behavior that obtains elsewhere in the DOM if the subtree you're looking at is deleted from its parent, so it's acceptable here. (If it really bothers folks, we could set things up so deleted subtrees are walked and marked invalid, but that's not part of the DOM's defined behavior.)

As a result, only the EntityReference itself has to be aware of changes in the Entity. And it can take advantage of the same structure-change-monitoring code I implemented to support DeepNodeList.

This class is based on an implementation from the Apache XML Project. In future releases the XML parser, XSLT processor, and associated classes will likely be updated to be based on a later version of the Apache implementations. Since Apache does not guarantee backwards compatibility between versions of their software, we cannot guarantee backwards compatibility of any of the classes contained in the weblogic.apache package or sub-packages.

Author:
  Arnaud Le Hors, IBM, Joe Kesselman, IBM, Andy Clark, IBM, Ralf Pfeiffer, IBM
See Also:
  Serialized Form

Field Summary
`protected java.lang.String` | `name` Name of Entity referenced

Fields inherited from class weblogic.apache.xerces.dom.ParentNode
`fCachedChild, fCachedChildIndex, fCachedLength, firstChild, ownerDocument`

Fields inherited from class weblogic.apache.xerces.dom.ChildNode
`nextSibling, previousSibling`

Fields inherited from class weblogic.apache.xerces.dom.NodeImpl
`ELEMENT_DEFINITION_NODE, FIRSTCHILD, flags, HASSTRING, IGNORABLEWS, OWNED, ownerNode, READONLY, SPECIFIED, SYNCCHILDREN, SYNCDATA, UNNORMALIZED`

Constructor Summary
`EntityReferenceImpl(CoreDocumentImpl ownerDoc, java.lang.String name)` Factory constructor.

Method Summary
`org.w3c.dom.NodeList` | `getChildNodes()` Perform synchronize() before accessing children.
`org.w3c.dom.Node` | `getFirstChild()` Perform synchronize() before accessing children.
`org.w3c.dom.Node` | `getLastChild()` Perform synchronize() before accessing children.
`int` | `getLength()` Query the number of children in the entity definition.
`java.lang.String` | `getNodeName()` Returns the name of the entity referenced
`short` | `getNodeType()` A short integer indicating what type of node this is.
`boolean` | `hasChildNodes()` Returns whether this node has any children.
`org.w3c.dom.Node` | `item(int index)` Returns the node at the given index.
`protected void` | `synchronize()` EntityReference's children are a reflection of those defined in the named Entity.

Methods inherited from class weblogic.apache.xerces.dom.ParentNode
`cloneNode, getChildNodesUnoptimized, getOwnerDocument, insertBefore, normalize, removeChild, replaceChild, setReadOnly, synchronizeChildren`

Methods inherited from class weblogic.apache.xerces.dom.ChildNode
`getNextSibling, getParentNode, getPreviousSibling`

Methods inherited from class weblogic.apache.xerces.dom.NodeImpl
`addEventListener, appendChild, changed, changes, dispatchEvent, getAttributes, getLocalName, getNamespaceURI, getNodeValue, getPrefix, getReadOnly, getUserData, hasAttributes, isSupported, removeEventListener, setNodeValue, setPrefix, setUserData, synchronizeData, toString`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Field Detail

### name

    protected java.lang.String name

  Name of Entity referenced

Constructor Detail

### EntityReferenceImpl

    public EntityReferenceImpl(CoreDocumentImpl ownerDoc,
                               java.lang.String name)

  Factory constructor.

Method Detail

### getNodeType

    public short getNodeType()

  A short integer indicating what type of node this is. The named constants for this value are defined in the org.w3c.dom.Node interface.

  Overrides:
    getNodeType in class NodeImpl

### getNodeName

    public java.lang.String getNodeName()

  Returns the name of the entity referenced

  Overrides:
    getNodeName in class NodeImpl

### getChildNodes

    public org.w3c.dom.NodeList getChildNodes()

  Perform synchronize() before accessing children.

  Returns:
    org.w3c.dom.NodeList
  Overrides:
    getChildNodes in class ParentNode

### getFirstChild

    public org.w3c.dom.Node getFirstChild()

  Perform synchronize() before accessing children.

  Returns:
    org.w3c.dom.NodeList
  Overrides:
    getFirstChild in class ParentNode

### getLastChild

    public org.w3c.dom.Node getLastChild()

  Perform synchronize() before accessing children.

  Returns:
    org.w3c.dom.NodeList
  Overrides:
    getLastChild in class ParentNode

### getLength

    public int getLength()

  Query the number of children in the entity definition. (A bit more work than asking locally, but may be able to avoid or defer building the clone subtree.)

  Returns:
    org.w3c.dom.NodeList
  Overrides:
    getLength in class ParentNode

### hasChildNodes

    public boolean hasChildNodes()

  Returns whether this node has any children.

  Returns:
    boolean
  Overrides:
    hasChildNodes in class ParentNode

### item

    public org.w3c.dom.Node item(int index)

  Returns the node at the given index.

  Overrides:
    item in class ParentNode

### synchronize

    protected void synchronize()

  EntityReference's children are a reflection of those defined in the named Entity. This method creates them if they haven't been created yet. This doesn't really support editing the Entity though.

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| Documentation is available at http://e-docs.bea.com/wls/docs70
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2004 BEA Systems, Inc. All Rights Reserved.
WebLogic Server 7.0 API Reference